/**********************************************************************

	--- Qt Architect generated file ---

	File: EditCurveWin.cpp
	Last generated: Sun Aug 15 17:55:43 1999

 *********************************************************************/

#include "EditCurveWin.h"
#include "EditPointWin.h"
#include <qmessagebox.h>

#define Inherited EditCurveWinData

const int XVAL_COL=18;
const int YVAL_COL=28;

EditCurveWin::EditCurveWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Edit Data" );
}

EditCurveWin::EditCurveWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL)
{
char text[50];

	setCaption( "Edit Data" );
	
	gffile = gff;
	
	init();

	popup = new QPopupMenu;	
	
	popup->insertItem("Cut",this,SLOT(cutPoint()));
	popup->insertItem("Copy",this,SLOT(copyPoint()));
	paste_id = popup->insertItem("Paste",this,SLOT(pastePoint()));
	popup->insertSeparator();
	popup->insertItem("Edit...",this,SLOT(editPoint()));
	popup->insertSeparator();
	popup->insertItem("Insert After...",this,SLOT(insertAfter()));
	popup->insertSeparator();
	popup->insertItem("Break Curve After",this,SLOT(breakCurve()));
	
	popup->setItemEnabled(paste_id,FALSE);
	
	strcpy(text,"Type");
	textPad(text,XVAL_COL);
	strcat(text,"X Value");
	textPad(text,YVAL_COL);
	strcat(text,"Y Value");
	
	data_label->setText(text);
		
}
void EditCurveWin::init()
{
int i;
char text[50];

	curve_combobox->clear();

	for(i=0;i<gffile->numCurves();i++)
	{
		sprintf(text,"%i",i+1);
		curve_combobox->insertItem(text);
	}
	
	curve_combobox->setCurrentItem(0);
	
	list_flag = 0;
	
	changeCurve(0);
}

EditCurveWin::~EditCurveWin()
{
}

void EditCurveWin::changeCurve(int c)
{
int i,iv;
float x,y;
char text[100];

	data_listbox->clear();
	
	curve = gffile->curve(c);
	
	curve_index = c;
	
	for(i=0;i<curve.numPoints();i++)
	{
		iv = curve.pointInvec(i);
		x = curve.pointX(i);
		y = curve.pointY(i);
		formatDataLine(text,iv,x,y);
		data_listbox->insertItem(text);
	}
	
	list_flag = 1;
	data_listbox->setCurrentItem(0);
	list_flag = 0;

}

void EditCurveWin::formatDataLine(char *text,int iv,float x,float y)
{
char line[100];

	if(iv < NUM_INVEC_NAMES)
	{
		sprintf(text,"%s",invec_names[iv]);
		textPad(text,XVAL_COL);
		sprintf(line,"%g",x);
		strcat(text,line);
		textPad(text,YVAL_COL);
		sprintf(line,"%g",y);
		strcat(text,line);
	}
	else
	{
		sprintf(text,"%i",iv);
		textPad(text,XVAL_COL);
		sprintf(line,"%g",x);
		strcat(text,line);
		textPad(text,YVAL_COL);
		sprintf(line,"%g",y);
		strcat(text,line);
	}
}

void EditCurveWin::textPad(char *text,unsigned int len)
{
// pads out the text to len with spaces
unsigned int i;

	if(strlen(text) >= len) return;
	
	for(i=strlen(text);i<=len;i++)
	{
		strcat(text," ");
	}
}

void EditCurveWin::dismiss()
{
	done(0);
}

void EditCurveWin::showPopup(int pt)
{

	if(list_flag == 1) return;
	
	point = pt;
	
QCursor cursor;

	popup->popup(cursor.pos());
}

void EditCurveWin::editPoint()
{
EditPointWin win(this);
int iv;
float x,y;
char text[100];
int pt;

	pt = point;

	iv = curve.pointInvec(pt);
	x = curve.pointX(pt);
	y = curve.pointY(pt);

	win.setValues(iv,x,y);
	
	if(win.exec() == 1) // accepted
	{	
		win.getValues(&iv,&x,&y);
		
		if(iv != 0 || pt == 0) // need to split curves to handle iv == 0
		{
		
			curve.setPoint(pt,iv,x,y);
		
			gffile->setCurve(curve_index,&curve);
		
			formatDataLine(text,iv,x,y);
		
			data_listbox->changeItem(text,pt);
		
			emit dataChanged();
		}
		else
		{
			QMessageBox mb("New Line",
			"Splitting a curve by inserting a new line\nControl is not supported",
			QMessageBox::Warning,QMessageBox::Ok|QMessageBox::Default,
			0,0,this);
			
			mb.exec();
		}
	}

}

void EditCurveWin::cutPoint()
{
int pt;

	pt = point;
	
	if(pt == 0)
	{
		QMessageBox mb("New Line",
		"Curve must start with 'New Line' data point\nChange its data values instead.",
		QMessageBox::Warning,QMessageBox::Ok|QMessageBox::Default,
		0,0,this);
			
		mb.exec();
		
		return;
	}
	
	iv_paste = curve.pointInvec(pt);
	x_paste = curve.pointX(pt);
	y_paste = curve.pointY(pt);
	
	curve.removePoint(pt);
	
	gffile->setCurve(curve_index,&curve);
	
	list_flag = 1;
	data_listbox->removeItem(pt);
	list_flag = 0;
	
	popup->setItemEnabled(paste_id,TRUE);
	
	emit dataChanged();
}

void EditCurveWin::copyPoint()
{
int pt;

	pt = point;
	
	iv_paste = curve.pointInvec(pt);
	x_paste = curve.pointX(pt);
	y_paste = curve.pointY(pt);
	
	popup->setItemEnabled(paste_id,TRUE);

}
void EditCurveWin::pastePoint()
{
char text[100];

	curve.insertPoint(point,iv_paste,x_paste,y_paste);
	
	gffile->setCurve(curve_index,&curve);
	
	formatDataLine(text,iv_paste,x_paste,y_paste);
	
	list_flag = 1;
	data_listbox->insertItem(text,point+1);
	list_flag = 0;
	
	emit dataChanged();

}

void EditCurveWin::insertAfter()
{
EditPointWin win(this);
int iv;
float x,y;
char text[100];
int pt;

	pt = point;

	iv = curve.pointInvec(pt);
	x = curve.pointX(pt);
	y = curve.pointY(pt);

	win.setValues(iv,x,y);
	
	if(win.exec() == 1) // accepted
	{	
		win.getValues(&iv,&x,&y);
		
		if(iv != 0 || pt == 0) // need to split curves to handle iv == 0
		{
		
			curve.insertPoint(pt,iv,x,y);
		
			gffile->setCurve(curve_index,&curve);
		
			formatDataLine(text,iv,x,y);
		
			list_flag = 1;
			data_listbox->insertItem(text,pt+1);
			list_flag = 0;
		
			emit dataChanged();
		}
		else
		{
			QMessageBox mb("New Line",
			"Splitting a curve by inserting a new line\nControl is not supported",
			QMessageBox::Warning,QMessageBox::Ok|QMessageBox::Default,
			0,0,this);
			
			mb.exec();
		}
	}
}

void EditCurveWin::breakCurve()
{
int curve = curve_index;
int pt = point;

	if(gffile->breakCurve(curve_index,point) == GF_OK)
	{	
		init();
		emit dataChanged();
		changeCurve(curve);
		list_flag = 1;
		data_listbox->setCurrentItem(pt);
		data_listbox->centerCurrentItem();
		list_flag = 0;
	}
}


